function [y] = lynn_filtr2 (x, fvz, fmez)
% Funkce lynn_filtr2.m filtruje signál x pomocí Lynnova filtru s více
% ekvidistálními propustnými pásmy. Je vhodná jak pro potlačení driftu, tak
% také pro potlačení brumu v užitečném signálu. Vstupy funkce jsou:
% x: vektor popisující signál, který má být filtrován pomocí Lynnova filtru
% fvz: kladné číslo charakterizující frekvenci, s kterou je signál x
% vzorkován
% fmez: kladné číslo charakterizující mezní frekvenci filtru
% Výstupem funkce lynn_filtr2.m je vektor y charakterizující získaný 
% vyfiltrovaný signál.

%získání koeficientu K
p=fvz/50;
delka=fvz/(fmez*p);
K=round(delka);

%výpočet koeficientů pro filtraci
b=zeros(1,p*K-p+1);
b(1:p:p*K-p+1) = 1/K ;
a=1;

%konvoluce impulsních charakteristik dvou filtrů v sérii
c=conv(b,b);

%kompenzace zpoždění
x=rot90(x);
x=[zeros(1,(K-1)*p),x];

%filtrace signálu
y=filtfilt(b, a, x);

%odstranění zpoždění
y=x-y;
y=y((K-1)*p+1:end);